## geonkick 2.3.7

=== debian/changelog ===
geonkick (2.3.7-0ubuntu1) groovy; urgency=medium

  * New upstream version 2.3.7
  * Source now includes manpage, removed lintian-override

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Mon, 14 Sep 2020 08:37:21 -0700

geonkick (2.3.6-0ubuntu1) groovy; urgency=medium

  * Initial release for Ubuntu

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sun, 16 Aug 2020 02:56:23 -0700

Old changelog:

geonkick (5:2.1.1-1kxstudio2) bionic; urgency=medium

  * Update

 -- falkTX <falktx@gmail.com>  Sun, 31 May 2020 07:35:38 +0100

geonkick (5:1.9.2-1kxstudio1) bionic; urgency=medium

  * Import, update and optimize

 -- falkTX <falktx@gmail.com>  Sun, 26 Jan 2020 19:41:03 +0000

geonkick (1.8.1-0librazik1) stretch; urgency=medium

  * Reconstruction avec pbuilder pour LibraZiK-2.
    - nouvelle version amont.

 -- Olivier Humbert <trebmuh@tuxfamily.org>  Sun, 11 Aug 2019 16:21:26 +0200

geonkick (1.8-0librazik1) stretch; urgency=medium

  * Reconstruction avec pbuilder pour LibraZiK-2.
    - nouvelle version amont.
  * debian/patches/build_fix.patch :
    - mise à jour de la rustine (avec dquilt).

 -- Olivier Humbert <trebmuh@tuxfamily.org>  Sat, 10 Aug 2019 16:45:43 +0200

geonkick (1.6-0librazik1) stretch; urgency=medium

  * Reconstruction avec pbuilder pour LibraZiK-2.
    - nouvelle version amont.

 -- Olivier Humbert <trebmuh@tuxfamily.org>  Fri, 07 Jun 2019 14:13:27 +0200

geonkick (1.5.3-0librazik1) stretch; urgency=medium

  * Reconstruction avec pbuilder pour LibraZiK-2.
    - nouvelle version amont.

 -- Olivier Humbert <trebmuh@tuxfamily.org>  Mon, 03 Jun 2019 23:20:49 +0200

geonkick (1.5.1-0librazik1) stretch; urgency=medium

  * Reconstruction avec pbuilder pour LibraZiK-2.
    - nouvelle version amont.
  * debian/watch :
    - adaptation à la nouvelle adresse.
  * debian/control :
    - Homepage : adaptation à la nouvelle adresse.
    - passage à 2019.
    - dépendances de construction : mise à jour.
  * debian/copyright :
    - Source : adaptation à la nouvelle adresse.
    - passage à 2019.
  * debian/patches/1001-desktop_file_FR.patch :
    - suppression de la rustine (intégrée en amont).
  * debian/patches/1000-fix_install.patch :
    - suppression de la rustine (inutile à présent).
  * debian/patches/build_fix.patch :
    - création de la rustine (avec dquilt).

 -- Olivier Humbert <trebmuh@tuxfamily.org>  Tue, 21 May 2019 11:10:18 +0200

geonkick (0.0.0+20181223~git34425e6-0librazik1) stretch; urgency=medium

  * Reconstruction avec pbuilder pour LibraZiK-2.
    - à partir du git du jour.
  * debian/control :
    - suppression des commentaires.
  * debian/patches/1000-fix_install.patch :
    - mise à jour de la rustine (à la main).
  * debian/patches/1001-desktop_file_FR.patch :
    - création de la rustine (avec dquilt).
  * debian/patches/series :
    - ajout de la rustine "1001-desktop_file_FR.patch" (avec dquilt).

 -- Olivier Humbert <trebmuh@tuxfamily.org>  Sun, 23 Dec 2018 14:21:48 +0100

geonkick (0.0.0+20181218~git410e5dd-0librazik1) stretch; urgency=medium

  * Construction initiale avec pbuilder pour LibraZiK-2.
  * debian/patches/1000-fix_install.patch :
    - ajout de la rustine (avec dquilt).

 -- Olivier Humbert <trebmuh@tuxfamily.org>  Tue, 18 Dec 2018 14:28:09 +0100

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/release-?(\d\S*)\.tar\.gz/geonkick-$1\.tar\.gz/ \
  https://github.com/iurie-sw/geonkick/tags .*/release-?(\d\S*)\.tar\.gz

## geonkick 2.3.8

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.7)

project(geonkick VERSION 2.3.8)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")
include(GNUInstallDirs)
include(FindRedkite)

option(GKICK_STANDALONE "Enable build for standalone" ON)
option(GKICK_PLUGIN "Enable build for plugin" ON)
if (GKICK_PLUGIN)
  option(GKICK_PLUGIN_LV2 "Enable build LV2 plugin" ON)
  if (GKICK_VST_SDK_PATH)
    option(GKICK_PLUGIN_VST "Enable build VST plugin" ON)
  else(GKICK_VST_SDK_PATH)
    option(GKICK_PLUGIN_VST "Enable build VST plugin" OFF)
  endif (GKICK_VST_SDK_PATH)
endif (GKICK_PLUGIN)

if (NOT CMAKE_BUILD_TYPE)
  message(STATUS "no build type selected, set default to Release")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type Release" FORCE)
endif()

if (NOT GKICK_ARCHITECTURE)
  message(STATUS "GKICK_ARCHITECTURE variable was not set use default ${CMAKE_HOST_SYSTEM_PROCESSOR}")
  set(GKICK_ARCHITECTURE ${CMAKE_HOST_SYSTEM_PROCESSOR})
endif ()

if (GKICK_ARCHITECTURE MATCHES x86_64)
  message(STATUS "set optimisation complier flags for ${GKICK_ARCHITECTURE}")
  set(GKICK_OPTIMISATION_FLAGS "-O3 -msse -msse2 -mfpmath=sse -ffast-math -fomit-frame-pointer")
else ()
  message(STATUS "set optimisation complier flags for ${GKICK_ARCHITECTURE}")
  set(GKICK_OPTIMISATION_FLAGS "-O3 -ffast-math -fomit-frame-pointer")
endif ()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_FLAGS "-Wall ${GKICK_OPTIMISATION_FLAGS} ${CMAKE_CXX_FLAGS} -fvisibility=hidden")
set(CMAKE_C_FLAGS "-Wall ${GKICK_OPTIMISATION_FLAGS} ${CMAKE_C_FLAGS} -fvisibility=hidden")

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set (CMAKE_INSTALL_PREFIX "/usr/local" CACHE PATH "default install path" FORCE)
endif()

if (NOT CMAKE_INSTALL_FULL_DATADIR)
  message(STATUS "CMAKE_INSTALL_FULL_DATADIR is not set, use default ${CMAKE_INSTALL_PREFIX}/share")
  set(CMAKE_INSTALL_FULL_DATADIR "${CMAKE_INSTALL_PREFIX}/share" CACHE PATH "default data dir path" FORCE)
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DGEONKICK_DATA_DIR=\\\"${CMAKE_INSTALL_FULL_DATADIR}\\\"")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DGEONKICK_DATA_DIR=\\\"${CMAKE_INSTALL_FULL_DATADIR}\\\"")

set(GKICK_DOC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/doc)
set(GKICK_API_DIR ${CMAKE_CURRENT_SOURCE_DIR}/dsp)
set(GKICK_COMMON_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(GKICK_RC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/resources)
set(GKICK_STANDALONE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/standalone)
set(GKICK_UTILS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/utils)

if (GKICK_PLUGIN)
  if (CMAKE_SYSTEM_NAME MATCHES Windows)
      if (GKICK_VST_SDK_PATH)
          list(APPEND CMAKE_MODULE_PATH "${GKICK_VST_SDK_PATH}/cmake/modules")
          include(Global)
          include(AddVST3Library)
      else(GKICK_VST_SDK_PATH)
          message(FATAL " GKICK_VST_SDK_PATH was not set")
      endif(GKICK_VST_SDK_PATH)
      set(GKICK_VST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/plugin/vst)
  else()
    if (GKICK_PLUGIN_VST)
      set(GKICK_VST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/plugin/vst)
    endif (GKICK_PLUGIN_VST)
    if (GKICK_PLUGIN_LV2)
      set(GKICK_LV2_DIR ${CMAKE_CURRENT_SOURCE_DIR}/plugin/lv2)
    endif (GKICK_PLUGIN_LV2)
  endif()
endif(GKICK_PLUGIN)

set(GKICK_DATA_DIR ${CMAKE_CURRENT_SOURCE_DIR}/data)
set(GKICK_PRESETS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/presets)

set(GKICK_COMMON_HEADERS
  ${GKICK_UTILS_DIR}/base64.h
  ${GKICK_COMMON_DIR}/geonkick_slider.h
  ${GKICK_COMMON_DIR}/geonkick_button.h
  ${GKICK_COMMON_DIR}/file_dialog.h
  ${GKICK_COMMON_DIR}/filter.h
  ${GKICK_COMMON_DIR}/geonkick_groupbox.h
  ${GKICK_COMMON_DIR}/top_bar.h
  ${GKICK_COMMON_DIR}/right_bar.h
  ${GKICK_COMMON_DIR}/control_area.h
  ${GKICK_COMMON_DIR}/controls_widget.h
  ${GKICK_COMMON_DIR}/percussion_model.h
  ${GKICK_COMMON_DIR}/kit_model.h
  ${GKICK_COMMON_DIR}/percussion_view.h
  ${GKICK_COMMON_DIR}/kit_widget.h
  ${GKICK_COMMON_DIR}/envelope_draw_area.h
  ${GKICK_COMMON_DIR}/limiter.h
  ${GKICK_COMMON_DIR}/general_envelope.h
  ${GKICK_COMMON_DIR}/effects_group_box.h
  ${GKICK_COMMON_DIR}/compressor_group_box.h
  ${GKICK_COMMON_DIR}/distortion_group_box.h
  ${GKICK_COMMON_DIR}/layers_group_box.h
  ${GKICK_COMMON_DIR}/general_group_box.h
  ${GKICK_COMMON_DIR}/envelope.h
  ${GKICK_COMMON_DIR}/kick_graph.h
  ${GKICK_COMMON_DIR}/envelope_widget.h
  ${GKICK_COMMON_DIR}/knob.h
  ${GKICK_COMMON_DIR}/oscillator.h
  ${GKICK_COMMON_DIR}/geonkick_api.h
  ${GKICK_COMMON_DIR}/percussion_state.h
  ${GKICK_COMMON_DIR}/kit_state.h
  ${GKICK_COMMON_DIR}/oscillator_envelope.h
  ${GKICK_COMMON_DIR}/oscillator_group_box.h
  ${GKICK_COMMON_DIR}/about.h
  ${GKICK_COMMON_DIR}/export_widget.h
  ${GKICK_COMMON_DIR}/preset.h
  ${GKICK_COMMON_DIR}/preset_folder.h
  ${GKICK_COMMON_DIR}/preset_browser_model.h
  ${GKICK_COMMON_DIR}/preset_browser_view.h
  ${GKICK_COMMON_DIR}/mainwindow.h)

set(GKICK_COMMON_SOURCES
  ${GKICK_UTILS_DIR}/base64.cpp
  ${GKICK_COMMON_DIR}/geonkick_widget.cpp
  ${GKICK_COMMON_DIR}/geonkick_slider.cpp
  ${GKICK_COMMON_DIR}/geonkick_button.cpp
  ${GKICK_COMMON_DIR}/file_dialog.cpp
  ${GKICK_COMMON_DIR}/filter.cpp
  ${GKICK_COMMON_DIR}/geonkick_groupbox.cpp
  ${GKICK_COMMON_DIR}/top_bar.cpp
  ${GKICK_COMMON_DIR}/right_bar.cpp
  ${GKICK_COMMON_DIR}/control_area.cpp
  ${GKICK_COMMON_DIR}/controls_widget.cpp
  ${GKICK_COMMON_DIR}/percussion_model.cpp
  ${GKICK_COMMON_DIR}/kit_model.cpp
  ${GKICK_COMMON_DIR}/percussion_view.cpp
  ${GKICK_COMMON_DIR}/kit_widget.cpp
  ${GKICK_COMMON_DIR}/envelope_draw_area.cpp
  ${GKICK_COMMON_DIR}/limiter.cpp
  ${GKICK_COMMON_DIR}/general_envelope.cpp
  ${GKICK_COMMON_DIR}/effects_group_box.cpp
  ${GKICK_COMMON_DIR}/compressor_group_box.cpp
  ${GKICK_COMMON_DIR}/distortion_group_box.cpp
  ${GKICK_COMMON_DIR}/layers_group_box.cpp
  ${GKICK_COMMON_DIR}/general_group_box.cpp
  ${GKICK_COMMON_DIR}/envelope.cpp
  ${GKICK_COMMON_DIR}/kick_graph.cpp
  ${GKICK_COMMON_DIR}/envelope_widget.cpp
  ${GKICK_COMMON_DIR}/knob.cpp
  ${GKICK_COMMON_DIR}/oscillator.cpp
  ${GKICK_COMMON_DIR}/geonkick_api.cpp
  ${GKICK_COMMON_DIR}/percussion_state.cpp
  ${GKICK_COMMON_DIR}/kit_state.cpp
  ${GKICK_COMMON_DIR}/oscillator_envelope.cpp
  ${GKICK_COMMON_DIR}/oscillator_group_box.cpp
  ${GKICK_COMMON_DIR}/export_widget.cpp
  ${GKICK_COMMON_DIR}/about.cpp
  ${GKICK_COMMON_DIR}/preset.cpp
  ${GKICK_COMMON_DIR}/preset_folder.cpp
  ${GKICK_COMMON_DIR}/preset_browser_model.cpp
  ${GKICK_COMMON_DIR}/preset_browser_view.cpp
  ${GKICK_COMMON_DIR}/mainwindow.cpp)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    message(STATUS "Enable application logging")
    option(ENABLE_LOGGING    "Enable logging for API and GUI" ON)
endif()

if (ENABLE_LOGGING)
  message(STATUS "set debug level")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DRK_LOG_DEBUG_LEVEL")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DRK_LOG_DEBUG_LEVEL")
  list(APPEND GKICK_API_FLAGS "-DGKICK_LIB_LOG_LEVEL_DEBUG")
  list(APPEND GKICK_API_FLAGS "-DGKICK_LIB_LOG_FUNCTION")
  list(APPEND GKICK_API_PLUGIN_FLAGS "-DGKICK_LIB_LOG_LEVEL_DEBUG")
  list(APPEND GKICK_API_PLUGIN_FLAGS "-DGKICK_LIB_LOG_FUNCTION")
endif()

find_package(PkgConfig REQUIRED)
pkg_check_modules(SNDFILE sndfile)
if (NOT SNDFILE_FOUND)
    message(FATAL_ERROR "can't find sndfile library")
endif(NOT SNDFILE_FOUND)

if (GKICK_STANDALONE)
  pkg_check_modules(JACK jack)
  if (NOT JACK_FOUND)
    message(FATAL_ERROR "can't find jack library")
  endif(NOT JACK_FOUND)
  list(APPEND GKICK_API_FLAGS "-DGEONKICK_AUDIO_JACK")
endif()

if (GKICK_PLUGIN)
  if(CMAKE_SYSTEM_NAME MATCHES Windows)
	message(STATUS "checking for VST SDK...")
  else()
	message(STATUS "checking for LV2 library...")
	pkg_check_modules(LV2 lv2)
	if (NOT LV2_FOUND)
		message(FATAL_ERROR "can't find LV2 library")
	endif(NOT LV2_FOUND)
  endif()
endif(GKICK_PLUGIN)

if (CMAKE_SYSTEM_NAME MATCHES Windows)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DRK_OS_WIN")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DRK_OS_WIN")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DRK_FOR_SHARED")
else ()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DRK_OS_GNU")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DRK_OS_GNU")
endif ()

include_directories(${GKICK_API_DIR}/src)
include_directories(${GKICK_UTILS_DIR})
set(CMAKE_INCLUDE_CURRENT_DIR ON)
add_definitions(-fPIC)
add_subdirectory(dsp)

if (CMAKE_SYSTEM_NAME MATCHES Windows)
    include_directories(${GKICK_VST_SDK_PATH})
    include_directories(${GKICK_REDKITE_SDK_PATH}/include)
    link_directories(${GKICK_VST_SDK_PATH}/build/lib/Debug)
    link_directories(${GKICK_REDKITE_SDK_PATH}/lib)
else ()
    include_directories(${REDKITE_INCLUDE_DIR})
    link_directories(${REDKITE_LIBRARY})
endif()

include(${GKICK_RC_DIR}/resources.rc)

foreach(pngFile ${gkick_rc_png_files})
  message(STATUS "convert file ${pngFile}")
  get_filename_component(filename ${GKICK_RC_DIR}/${pngFile} NAME)
  string(REPLACE "." "_" filename ${filename})
  string(REPLACE " " "_" filename ${filename})
  add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/resources/${filename}.c
    COMMAND mkdir -p ${CMAKE_BINARY_DIR}/resources
    && rkpng2c "${GKICK_RC_DIR}/${pngFile}" "${CMAKE_BINARY_DIR}/resources/${filename}.c" "rk__${filename}")
    set(GKICK_RC_OUTPUT ${GKICK_RC_OUTPUT} ${CMAKE_BINARY_DIR}/resources/${filename}.c)
endforeach()

add_custom_target(gkick_resources ALL DEPENDS ${GKICK_RC_OUTPUT})

include_directories(${GKICK_COMMON_DIR})
link_directories(${REDKITE_LIBRARY_DIR})
add_library(geonkick_common STATIC
  ${GKICK_COMMON_HEADERS}
  ${GKICK_COMMON_SOURCES}
  ${GKICK_RC_OUTPUT})
add_dependencies(geonkick_common gkick_resources)

message(STATUS "------------ Summary ---------")
if (GKICK_STANDALONE)
  message(STATUS "Standalone: yes" )
else(GKICK_STANDALONE)
  message(STATUS "Standalone: no")
endif(GKICK_STANDALONE)

if (GKICK_PLUGIN_LV2)
  message(STATUS "LV2 plugin: yes" )
else(GKICK_PLUGIN_LV2)
  message(STATUS "LV2 plugin: no")
endif(GKICK_PLUGIN_LV2)

if (GKICK_PLUGIN_VST)
  message(STATUS "VST plugin: yes" )
else(GKICK_PLUGIN_VST)
  message(STATUS "VST plugin: no")
endif(GKICK_PLUGIN_VST)

if (ENABLE_LOGGING)
  message(STATUS "Debug enabled: yes" )
else(ENABLE_LOGGING)
  message(STATUS "Debug enabled: no" )
endif(ENABLE_LOGGING)
message(STATUS "------------------------------")

if (GKICK_STANDALONE)
  add_subdirectory(standalone)
endif (GKICK_STANDALONE)

if (GKICK_PLUGIN)
	add_subdirectory(plugin)
endif (GKICK_PLUGIN)

add_subdirectory(data)
add_subdirectory(presets)

=== dsp/CMakeLists.txt ===
set(GKICK_API_HEADERS
	${GKICK_API_DIR}/src/audio_output.h
	${GKICK_API_DIR}/src/compressor.h
	${GKICK_API_DIR}/src/distortion.h
	${GKICK_API_DIR}/src/envelope.h
	${GKICK_API_DIR}/src/filter.h
	${GKICK_API_DIR}/src/geonkick.h
	${GKICK_API_DIR}/src/geonkick_internal.h
	${GKICK_API_DIR}/src/gkick_audio.h
        ${GKICK_API_DIR}/src/mixer.h
	${GKICK_API_DIR}/src/gkick_buffer.h
	${GKICK_API_DIR}/src/gkick_log.h
	${GKICK_API_DIR}/src/oscillator.h
	${GKICK_API_DIR}/src/synthesizer.h)

if (GKICK_STANDALONE)
  list(APPEND GKICK_API_HEADERS ${GKICK_API_DIR}/src/gkick_jack.h)
endif(GKICK_STANDALONE)

set(GKICK_API_SOURCES
	${GKICK_API_DIR}/src/audio_output.c
	${GKICK_API_DIR}/src/compressor.c
	${GKICK_API_DIR}/src/distortion.c
	${GKICK_API_DIR}/src/envelope.c
	${GKICK_API_DIR}/src/filter.c
	${GKICK_API_DIR}/src/geonkick.c
	${GKICK_API_DIR}/src/gkick_audio.c
        ${GKICK_API_DIR}/src/mixer.c
	${GKICK_API_DIR}/src/gkick_buffer.c
	${GKICK_API_DIR}/src/gkick_log.c
	${GKICK_API_DIR}/src/oscillator.c
	${GKICK_API_DIR}/src/synthesizer.c)

if (GKICK_STANDALONE)
  list(APPEND GKICK_API_SOURCES ${GKICK_API_DIR}/src/gkick_jack.c)
endif(GKICK_STANDALONE)

include_directories(${GKICK_API_DIR}/src)

if (GKICK_STANDALONE)
	add_library(api_standalone STATIC
		${GKICK_API_HEADERS}
		${GKICK_API_SOURCES})
	target_compile_options(api_standalone PUBLIC ${GKICK_API_FLAGS})
endif (GKICK_STANDALONE)

if (GKICK_PLUGIN)
	add_library(api_plugin STATIC
		${GKICK_API_HEADERS}
		${GKICK_API_SOURCES})
	target_compile_options(api_plugin PUBLIC ${GKICK_API_PLUGIN_FLAGS})
endif (GKICK_PLUGIN)

=== plugin/lv2/CMakeLists.txt ===
set(GKICK_LV2_SOURCES ${GKICK_LV2_DIR}/geonkick_lv2.cpp)

add_library(geonkick_lv2 SHARED
  ${GKICK_COMMON_HEADERS}
  ${GKICK_COMMON_RESOURCES}
  ${GKICK_LV2_SOURCES})

target_link_libraries(geonkick_lv2  geonkick_common api_plugin)
target_link_libraries(geonkick_lv2 "-lstdc++fs")
target_link_libraries(geonkick_lv2 "-lredkite -lX11 -lsndfile -lrt -lm -ldl -lpthread -lcairo")
add_dependencies(geonkick_lv2 api_plugin)

install(DIRECTORY ${GKICK_LV2_DIR}/geonkick.lv2 DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/lv2)
install(TARGETS geonkick_lv2 DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/lv2/geonkick.lv2)

=== debian/changelog ===
geonkick (2.3.8-0ubuntu1) groovy; urgency=medium

  * New upstream release
    - Fixes the looped continuous sound that is generated on some hosts
      (LV2 and VST3)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Tue, 22 Sep 2020 12:30:03 -0700

## geonkick 2.5.0

=== debian/changelog ===
geonkick (2.5.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release 2.5.0
    - sample browser with sample preview
    - save/restore the last visited path, also save UI visual state
    - loaded sample is amplified
    - pitch shift (+- 48 semitones) envelope for oscillator when it uses a
      sample
    - added sound level indication for kit mixer
    - UI updates, switch between envelopes is more easy, removed the envelopes
      menu
    - option to scale the UI by factor of 2 for so-called HiDPI cases
      (Left Ctrl + f)
    - shared worker between plugin instances
    - "Single" version of LV2 plugin (single instrument and single stereo
      channel)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Tue, 03 Nov 2020 14:19:04 -0800

=== debian/control ===
Source: geonkick
Section: sound
Priority: optional
Maintainer: Erich Eickmeyer <eeickmeyer@ubuntu.com>
XSBC-Original-Maintainer: Equipe LibraZiK <librazik@tuxfamily.org>
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libcairo2-dev,
 libjack-jackd2-dev | libjack-dev,
 libx11-dev,
 lv2-dev,
 pkg-config,
 rapidjson-dev,
 libredkite-dev,
 libsndfile1-dev
Standards-Version: 4.5.0
Homepage: https://github.com/iurie-sw/geonkick

Package: geonkick
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Provides: standalone-plugin, lv2-plugin
Description: Kick drum synthesizer
 Geonkick is a synthesizer that can synthesize elements of percussion. The most
 basic examples are: kick drums, snares, hit-hats, shakers, claps, steaks.
 .
 Available as an LV2 plugin and JACK standalone version.

## geonkick 2.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 3.7)
 
-project(geonkick VERSION 2.3.8)
+project(geonkick VERSION 2.6.0)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")
 include(GNUInstallDirs)
@@ -36,6 +36,8 @@
 endif ()
 
 set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
 set(CMAKE_CXX_FLAGS "-Wall ${GKICK_OPTIMISATION_FLAGS} ${CMAKE_CXX_FLAGS} -fvisibility=hidden")
 set(CMAKE_C_FLAGS "-Wall ${GKICK_OPTIMISATION_FLAGS} ${CMAKE_C_FLAGS} -fvisibility=hidden")
 
@@ -83,13 +85,17 @@
 
 set(GKICK_COMMON_HEADERS
   ${GKICK_UTILS_DIR}/base64.h
+  ${GKICK_COMMON_DIR}/GeonkickConfig.h
+  ${GKICK_COMMON_DIR}/UiSettings.h
+  ${GKICK_COMMON_DIR}/ViewState.h
   ${GKICK_COMMON_DIR}/geonkick_slider.h
   ${GKICK_COMMON_DIR}/geonkick_button.h
+  ${GKICK_COMMON_DIR}/PathListModel.h
   ${GKICK_COMMON_DIR}/file_dialog.h
+  ${GKICK_COMMON_DIR}/SampleBrowser.h
   ${GKICK_COMMON_DIR}/filter.h
   ${GKICK_COMMON_DIR}/geonkick_groupbox.h
   ${GKICK_COMMON_DIR}/top_bar.h
-  ${GKICK_COMMON_DIR}/right_bar.h
   ${GKICK_COMMON_DIR}/control_area.h
   ${GKICK_COMMON_DIR}/controls_widget.h
   ${GKICK_COMMON_DIR}/percussion_model.h
@@ -105,6 +111,7 @@
   ${GKICK_COMMON_DIR}/layers_group_box.h
   ${GKICK_COMMON_DIR}/general_group_box.h
   ${GKICK_COMMON_DIR}/envelope.h
+  ${GKICK_COMMON_DIR}/BufferView.h
   ${GKICK_COMMON_DIR}/kick_graph.h
   ${GKICK_COMMON_DIR}/envelope_widget.h
   ${GKICK_COMMON_DIR}/knob.h
@@ -114,24 +121,31 @@
   ${GKICK_COMMON_DIR}/kit_state.h
   ${GKICK_COMMON_DIR}/oscillator_envelope.h
   ${GKICK_COMMON_DIR}/oscillator_group_box.h
-  ${GKICK_COMMON_DIR}/about.h
+  ${GKICK_COMMON_DIR}/ExportAbstract.h
+  ${GKICK_COMMON_DIR}/ExportSoundData.h
+  ${GKICK_COMMON_DIR}/ExportToSfz.h
   ${GKICK_COMMON_DIR}/export_widget.h
   ${GKICK_COMMON_DIR}/preset.h
   ${GKICK_COMMON_DIR}/preset_folder.h
   ${GKICK_COMMON_DIR}/preset_browser_model.h
   ${GKICK_COMMON_DIR}/preset_browser_view.h
+  ${GKICK_COMMON_DIR}/MidiKeyWidget.h
   ${GKICK_COMMON_DIR}/mainwindow.h)
 
 set(GKICK_COMMON_SOURCES
   ${GKICK_UTILS_DIR}/base64.cpp
+  ${GKICK_COMMON_DIR}/GeonkickConfig.cpp
+  ${GKICK_COMMON_DIR}/UiSettings.cpp
+  ${GKICK_COMMON_DIR}/ViewState.cpp
   ${GKICK_COMMON_DIR}/geonkick_widget.cpp
   ${GKICK_COMMON_DIR}/geonkick_slider.cpp
   ${GKICK_COMMON_DIR}/geonkick_button.cpp
+  ${GKICK_COMMON_DIR}/PathListModel.cpp
   ${GKICK_COMMON_DIR}/file_dialog.cpp
+  ${GKICK_COMMON_DIR}/SampleBrowser.cpp
   ${GKICK_COMMON_DIR}/filter.cpp
   ${GKICK_COMMON_DIR}/geonkick_groupbox.cpp
   ${GKICK_COMMON_DIR}/top_bar.cpp
-  ${GKICK_COMMON_DIR}/right_bar.cpp
   ${GKICK_COMMON_DIR}/control_area.cpp
   ${GKICK_COMMON_DIR}/controls_widget.cpp
   ${GKICK_COMMON_DIR}/percussion_model.cpp
@@ -147,6 +161,7 @@
   ${GKICK_COMMON_DIR}/layers_group_box.cpp
   ${GKICK_COMMON_DIR}/general_group_box.cpp
   ${GKICK_COMMON_DIR}/envelope.cpp
+  ${GKICK_COMMON_DIR}/BufferView.cpp
   ${GKICK_COMMON_DIR}/kick_graph.cpp
   ${GKICK_COMMON_DIR}/envelope_widget.cpp
   ${GKICK_COMMON_DIR}/knob.cpp
@@ -157,11 +172,14 @@
   ${GKICK_COMMON_DIR}/oscillator_envelope.cpp
   ${GKICK_COMMON_DIR}/oscillator_group_box.cpp
   ${GKICK_COMMON_DIR}/export_widget.cpp
-  ${GKICK_COMMON_DIR}/about.cpp
+  ${GKICK_COMMON_DIR}/ExportAbstract.cpp
+  ${GKICK_COMMON_DIR}/ExportSoundData.cpp
+  ${GKICK_COMMON_DIR}/ExportToSfz.cpp
   ${GKICK_COMMON_DIR}/preset.cpp
   ${GKICK_COMMON_DIR}/preset_folder.cpp
   ${GKICK_COMMON_DIR}/preset_browser_model.cpp
   ${GKICK_COMMON_DIR}/preset_browser_view.cpp
+  ${GKICK_COMMON_DIR}/MidiKeyWidget.cpp
   ${GKICK_COMMON_DIR}/mainwindow.cpp)
 
 if (CMAKE_BUILD_TYPE STREQUAL "Debug")
@@ -177,6 +195,8 @@
   list(APPEND GKICK_API_FLAGS "-DGKICK_LIB_LOG_FUNCTION")
   list(APPEND GKICK_API_PLUGIN_FLAGS "-DGKICK_LIB_LOG_LEVEL_DEBUG")
   list(APPEND GKICK_API_PLUGIN_FLAGS "-DGKICK_LIB_LOG_FUNCTION")
+  list(APPEND GKICK_API_PLUGIN_SINGLE_FLAGS "-DGKICK_LIB_LOG_LEVEL_DEBUG")
+  list(APPEND GKICK_API_PLUGIN_SINGLE_FLAGS "-DGKICK_LIB_LOG_FUNCTION")
 endif()
 
 find_package(PkgConfig REQUIRED)
@@ -194,6 +214,7 @@
 endif()
 
 if (GKICK_PLUGIN)
+  list(APPEND GKICK_API_PLUGIN_SINGLE_FLAGS "-DGEONKICK_SINGLE")
   if(CMAKE_SYSTEM_NAME MATCHES Windows)
 	message(STATUS "checking for VST SDK...")
   else()
@@ -201,7 +222,7 @@
 	pkg_check_modules(LV2 lv2)
 	if (NOT LV2_FOUND)
 		message(FATAL_ERROR "can't find LV2 library")
-	endif(NOT LV2_FOUND)
+	      endif(NOT LV2_FOUND)
   endif()
 endif(GKICK_PLUGIN)
 
@@ -253,6 +274,15 @@
   ${GKICK_RC_OUTPUT})
 add_dependencies(geonkick_common gkick_resources)
 
+if (GKICK_PLUGIN)
+    add_library(geonkick_common_single STATIC
+      ${GKICK_COMMON_HEADERS}
+      ${GKICK_COMMON_SOURCES}
+      ${GKICK_RC_OUTPUT})
+    add_dependencies(geonkick_common_single gkick_resources)
+    target_compile_options(geonkick_common_single PUBLIC ${GKICK_API_PLUGIN_SINGLE_FLAGS})
+endif(GKICK_PLUGIN)
+
 message(STATUS "------------ Summary ---------")
 if (GKICK_STANDALONE)
   message(STATUS "Standalone: yes" )

=== standalone/CMakeLists.txt ===
set(GKICK_STANDALONE_SOURCES ${GKICK_STANDALONE_DIR}/main.cpp)

add_executable(geonkick
  ${GKICK_COMMON_HEADERS}
  ${GKICK_COMMON_RESOURCES}
  ${GKICK_STANDALONE_SOURCES})

add_dependencies(geonkick api_standalone)
target_link_libraries(geonkick  geonkick_common api_standalone)
target_link_libraries(geonkick "-lstdc++fs")
target_link_libraries(geonkick "-lredkite -lX11 -ljack -lsndfile -lrt -lm -ldl -lpthread -lcairo")

install(TARGETS geonkick DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
install(FILES ${GKICK_DOC_DIR}/man/geonkick.1  DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)

=== plugin/lv2/CMakeLists.txt ===
--- 
+++ 
@@ -10,5 +10,18 @@
 target_link_libraries(geonkick_lv2 "-lredkite -lX11 -lsndfile -lrt -lm -ldl -lpthread -lcairo")
 add_dependencies(geonkick_lv2 api_plugin)
 
+if (GKICK_PLUGIN)
+  add_library(geonkick_single_lv2 SHARED
+    ${GKICK_COMMON_HEADERS}
+    ${GKICK_COMMON_RESOURCES}
+    ${GKICK_LV2_SOURCES})
+  target_link_libraries(geonkick_single_lv2  geonkick_common_single api_plugin_single)
+  target_link_libraries(geonkick_single_lv2 "-lstdc++fs")
+  target_link_libraries(geonkick_single_lv2 "-lredkite -lX11 -lsndfile -lrt -lm -ldl -lpthread -lcairo")
+  add_dependencies(geonkick_single_lv2 api_plugin_single)
+  target_compile_options(geonkick_single_lv2 PUBLIC ${GKICK_API_PLUGIN_SINGLE_FLAGS})
+  install(TARGETS geonkick_single_lv2 DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/lv2/geonkick.lv2)
+endif(GKICK_PLUGIN)
+
+install(TARGETS geonkick_lv2 DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/lv2/geonkick.lv2)
 install(DIRECTORY ${GKICK_LV2_DIR}/geonkick.lv2 DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/lv2)
-install(TARGETS geonkick_lv2 DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/lv2/geonkick.lv2)

=== plugin/vst/CMakeLists.txt ===
set(GKICK_VST_DIR ${CMAKE_CURRENT_SOURCE_DIR})
if (GKICK_VST_SDK_PATH)
  list(APPEND CMAKE_MODULE_PATH "${GKICK_VST_SDK_PATH}/cmake/modules")
  include(Global)
  include(AddVST3Library)
else (GKICK_VST_SDK_PATH)
  message(STATUS "GKICK_VST_SDK_PATH was not set")
endif(GKICK_VST_SDK_PATH)

include_directories(${GKICK_VST_SDK_PATH})
include_directories(${GKICK_REDKITE_SDK_PATH}/include)
link_directories(${GKICK_VST_SDK_PATH}/build/lib/Debug)
link_directories(${GKICK_REDKITE_SDK_PATH}/lib)

set(GKICK_VST_HEADERS
  ${GKICK_VST_SDK_PATH}/public.sdk/source/vst/vstsinglecomponenteffect.h
  ${GKICK_VST_DIR}/VstIds.h
  ${GKICK_VST_DIR}/GKickVstProcessor.h
  ${GKICK_VST_DIR}/GKickVstEditor.h)

set(GKICK_VST_SOURCES
  ${GKICK_VST_SDK_PATH}/public.sdk/source/vst/vstsinglecomponenteffect.cpp
  ${GKICK_VST_DIR}/VstFactory.cpp
  ${GKICK_VST_DIR}/GKickVstProcessor.cpp
  ${GKICK_VST_DIR}/GKickVstEditor.cpp)

set(target geonkick_vst)
smtg_get_linux_architecture_name()
smtg_add_vst3plugin(${target} ${GKICK_VST_HEADERS} ${GKICK_VST_SOURCES})

set_target_properties(${target} PROPERTIES PREFIX "")
set_target_properties(${target} PROPERTIES OUTPUT_NAME "geonkick")
set_target_properties(${target} PROPERTIES SUFFIX ".so")

target_link_libraries(${target} PRIVATE geonkick_common api_plugin)
target_link_libraries(${target} PRIVATE "-lstdc++fs")
target_link_libraries(${target} PRIVATE base sdk pluginterfaces)
target_link_libraries(${target} PRIVATE "-lredkite -lX11 -lsndfile -lrt -lm -ldl -lpthread -lcairo")
target_link_libraries(${target} PRIVATE "-Wl,--no-undefined")

add_dependencies(${target} geonkick_common)

install(TARGETS geonkick_vst DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/vst3/geonkick.vst3/Contents/${LINUX_ARCHITECTURE_NAME})

## geonkick 2.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 3.7)
 
-project(geonkick VERSION 2.6.0)
+project(geonkick VERSION 2.7.0)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")
 include(GNUInstallDirs)
@@ -10,11 +10,6 @@
 option(GKICK_PLUGIN "Enable build for plugin" ON)
 if (GKICK_PLUGIN)
   option(GKICK_PLUGIN_LV2 "Enable build LV2 plugin" ON)
-  if (GKICK_VST_SDK_PATH)
-    option(GKICK_PLUGIN_VST "Enable build VST plugin" ON)
-  else(GKICK_VST_SDK_PATH)
-    option(GKICK_PLUGIN_VST "Enable build VST plugin" OFF)
-  endif (GKICK_VST_SDK_PATH)
 endif (GKICK_PLUGIN)
 
 if (NOT CMAKE_BUILD_TYPE)
@@ -62,18 +57,7 @@
 
 if (GKICK_PLUGIN)
   if (CMAKE_SYSTEM_NAME MATCHES Windows)
-      if (GKICK_VST_SDK_PATH)
-          list(APPEND CMAKE_MODULE_PATH "${GKICK_VST_SDK_PATH}/cmake/modules")
-          include(Global)
-          include(AddVST3Library)
-      else(GKICK_VST_SDK_PATH)
-          message(FATAL " GKICK_VST_SDK_PATH was not set")
-      endif(GKICK_VST_SDK_PATH)
-      set(GKICK_VST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/plugin/vst)
   else()
-    if (GKICK_PLUGIN_VST)
-      set(GKICK_VST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/plugin/vst)
-    endif (GKICK_PLUGIN_VST)
     if (GKICK_PLUGIN_LV2)
       set(GKICK_LV2_DIR ${CMAKE_CURRENT_SOURCE_DIR}/plugin/lv2)
     endif (GKICK_PLUGIN_LV2)
@@ -242,9 +226,7 @@
 add_subdirectory(dsp)
 
 if (CMAKE_SYSTEM_NAME MATCHES Windows)
-    include_directories(${GKICK_VST_SDK_PATH})
     include_directories(${GKICK_REDKITE_SDK_PATH}/include)
-    link_directories(${GKICK_VST_SDK_PATH}/build/lib/Debug)
     link_directories(${GKICK_REDKITE_SDK_PATH}/lib)
 else ()
     include_directories(${REDKITE_INCLUDE_DIR})
@@ -296,12 +278,6 @@
   message(STATUS "LV2 plugin: no")
 endif(GKICK_PLUGIN_LV2)
 
-if (GKICK_PLUGIN_VST)
-  message(STATUS "VST plugin: yes" )
-else(GKICK_PLUGIN_VST)
-  message(STATUS "VST plugin: no")
-endif(GKICK_PLUGIN_VST)
-
 if (ENABLE_LOGGING)
   message(STATUS "Debug enabled: yes" )
 else(ENABLE_LOGGING)

=== plugin/CMakeLists.txt ===
if (GKICK_PLUGIN_LV2)
  add_subdirectory(lv2)
endif(GKICK_PLUGIN_LV2)

=== plugin/lv2/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
   ${GKICK_COMMON_RESOURCES}
   ${GKICK_LV2_SOURCES})
 
+set_target_properties(geonkick_lv2 PROPERTIES PREFIX "")
 target_link_libraries(geonkick_lv2  geonkick_common api_plugin)
 target_link_libraries(geonkick_lv2 "-lstdc++fs")
 target_link_libraries(geonkick_lv2 "-lredkite -lX11 -lsndfile -lrt -lm -ldl -lpthread -lcairo")
@@ -15,6 +16,7 @@
     ${GKICK_COMMON_HEADERS}
     ${GKICK_COMMON_RESOURCES}
     ${GKICK_LV2_SOURCES})
+  set_target_properties(geonkick_single_lv2 PROPERTIES PREFIX "")
   target_link_libraries(geonkick_single_lv2  geonkick_common_single api_plugin_single)
   target_link_libraries(geonkick_single_lv2 "-lstdc++fs")
   target_link_libraries(geonkick_single_lv2 "-lredkite -lX11 -lsndfile -lrt -lm -ldl -lpthread -lcairo")

## geonkick 2.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 3.7)
 
-project(geonkick VERSION 2.7.0)
+project(geonkick VERSION 2.7.2)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")
 include(GNUInstallDirs)

=== debian/changelog ===
geonkick (2.7.2-0ubuntu1) hirsute; urgency=medium

  * New upstream bugfix release
  * Show Geonkick version in the UI
  * fix crash for standalone when jack server is not running

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Mon, 01 Mar 2021 08:02:01 -0800

geonkick (2.7.1-0ubuntu1) hirsute; urgency=medium

  * New upstream bugfix release
  * d/control: Build-dep redkite 1.3.1

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sat, 27 Feb 2021 10:32:36 -0800

geonkick (2.7.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release 2.7.0
  * Specify version of redkite in build-deps
  * Now sample rate agnostic

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 16 Dec 2020 09:03:29 -0800

geonkick (2.6.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release 2.6.0
  * Set MDI key popup for instruments
  * Export instrument kit to SFZ
  * 16 stereo channels for standalone
  * Autoconnect ports to system playback for standalone

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 16 Dec 2020 08:40:24 -0800

geonkick (2.5.1-0ubuntu1) hirsute; urgency=medium

  * New upstream release 2.5.1
    - Fix build for some distros (include iomanip)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 09 Dec 2020 09:02:51 -0800

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  lv2-dev,
  pkg-config,
  rapidjson-dev,
- libredkite-dev,
+ libredkite-dev (>= 1.3.1),
  libsndfile1-dev
 Standards-Version: 4.5.0
 Homepage: https://github.com/iurie-sw/geonkick

## geonkick 2.8.0

=== debian/changelog ===
geonkick (2.8.0-0ubuntu1) impish; urgency=medium

  * New upstream release 2.8.0
  * Fix crash when opening multiple GUI for LV2
  * Find rapidjson when configuring at build
  * add musl compatibility patch
  * Add limiter to samples preview
  * Integrate Redkite into Geonkick code

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 07 Jul 2021 17:36:15 +0000

geonkick (2.7.3-0ubuntu1) impish; urgency=medium

  * New upstream release 2.7.3
  * Redkite removed as build-dep, now included in source
  * Fix selection of the last MIDI column in the MIDI key popup
  * Bump copyright date

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sat, 12 Jun 2021 13:20:32 -0700

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,6 @@
  lv2-dev,
  pkg-config,
  rapidjson-dev,
- libredkite-dev (>= 1.3.1),
  libsndfile1-dev
 Standards-Version: 4.5.0
 Homepage: https://github.com/iurie-sw/geonkick

## geonkick 2.9.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,18 @@
 cmake_minimum_required (VERSION 3.7)
 
-project(geonkick VERSION 2.7.2)
+project(geonkick VERSION 2.9.0)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")
 include(GNUInstallDirs)
-include(FindRedkite)
 
 option(GKICK_STANDALONE "Enable build for standalone" ON)
 option(GKICK_PLUGIN "Enable build for plugin" ON)
+
 if (GKICK_PLUGIN)
   option(GKICK_PLUGIN_LV2 "Enable build LV2 plugin" ON)
+  if (GKICK_VST3)
+    option(GKICK_PLUGIN_VST "Enable build VST plugin" ON)
+  endif(GKICK_VST3)
 endif (GKICK_PLUGIN)
 
 if (NOT CMAKE_BUILD_TYPE)
@@ -54,14 +57,16 @@
 set(GKICK_RC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/resources)
 set(GKICK_STANDALONE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/standalone)
 set(GKICK_UTILS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/utils)
-
-if (GKICK_PLUGIN)
-  if (CMAKE_SYSTEM_NAME MATCHES Windows)
-  else()
+set(GKICK_REDKITE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/redkite)
+
+if (GKICK_PLUGIN)
+    if (GKICK_PLUGIN_VST)
+      set(GKICK_VST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/plugin/vst)
+      set(GKICK_VST_SDK_PATH ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/vst3_sdk)
+    endif (GKICK_PLUGIN_VST)
     if (GKICK_PLUGIN_LV2)
       set(GKICK_LV2_DIR ${CMAKE_CURRENT_SOURCE_DIR}/plugin/lv2)
     endif (GKICK_PLUGIN_LV2)
-  endif()
 endif(GKICK_PLUGIN)
 
 set(GKICK_DATA_DIR ${CMAKE_CURRENT_SOURCE_DIR}/data)
@@ -184,6 +189,7 @@
 endif()
 
 find_package(PkgConfig REQUIRED)
+find_package(RapidJSON REQUIRED)
 pkg_check_modules(SNDFILE sndfile)
 if (NOT SNDFILE_FOUND)
     message(FATAL_ERROR "can't find sndfile library")
@@ -192,7 +198,9 @@
 if (GKICK_STANDALONE)
   pkg_check_modules(JACK jack)
   if (NOT JACK_FOUND)
-    message(FATAL_ERROR "can't find jack library")
+    message(STATUS "can't find jack library")
+    set(GKICK_STANDALONE OFF)
+    set(GKICK_JACK_NOT_FOUND ON)
   endif(NOT JACK_FOUND)
   list(APPEND GKICK_API_FLAGS "-DGEONKICK_AUDIO_JACK")
 endif()
@@ -206,7 +214,7 @@
 	pkg_check_modules(LV2 lv2)
 	if (NOT LV2_FOUND)
 		message(FATAL_ERROR "can't find LV2 library")
-	      endif(NOT LV2_FOUND)
+        endif(NOT LV2_FOUND)
   endif()
 endif(GKICK_PLUGIN)
 
@@ -220,48 +228,28 @@
 endif ()
 
 include_directories(${GKICK_API_DIR}/src)
+include_directories(${GKICK_REDKITE_DIR}/include)
 include_directories(${GKICK_UTILS_DIR})
+link_directories(${CMAKE_BINARY_DIR}/redkite)
+
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 add_definitions(-fPIC)
 add_subdirectory(dsp)
-
-if (CMAKE_SYSTEM_NAME MATCHES Windows)
-    include_directories(${GKICK_REDKITE_SDK_PATH}/include)
-    link_directories(${GKICK_REDKITE_SDK_PATH}/lib)
-else ()
-    include_directories(${REDKITE_INCLUDE_DIR})
-    link_directories(${REDKITE_LIBRARY})
-endif()
-
+add_subdirectory(redkite)
 include(${GKICK_RC_DIR}/resources.rc)
-
-foreach(pngFile ${gkick_rc_png_files})
-  message(STATUS "convert file ${pngFile}")
-  get_filename_component(filename ${GKICK_RC_DIR}/${pngFile} NAME)
-  string(REPLACE "." "_" filename ${filename})
-  string(REPLACE " " "_" filename ${filename})
-  add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/resources/${filename}.c
-    COMMAND mkdir -p ${CMAKE_BINARY_DIR}/resources
-    && rkpng2c "${GKICK_RC_DIR}/${pngFile}" "${CMAKE_BINARY_DIR}/resources/${filename}.c" "rk__${filename}")
-    set(GKICK_RC_OUTPUT ${GKICK_RC_OUTPUT} ${CMAKE_BINARY_DIR}/resources/${filename}.c)
-endforeach()
-
-add_custom_target(gkick_resources ALL DEPENDS ${GKICK_RC_OUTPUT})
 
 include_directories(${GKICK_COMMON_DIR})
 link_directories(${REDKITE_LIBRARY_DIR})
 add_library(geonkick_common STATIC
   ${GKICK_COMMON_HEADERS}
   ${GKICK_COMMON_SOURCES}
-  ${GKICK_RC_OUTPUT})
-add_dependencies(geonkick_common gkick_resources)
+  ${GKICK_RESOURCES})
 
 if (GKICK_PLUGIN)
     add_library(geonkick_common_single STATIC
       ${GKICK_COMMON_HEADERS}
       ${GKICK_COMMON_SOURCES}
-      ${GKICK_RC_OUTPUT})
-    add_dependencies(geonkick_common_single gkick_resources)
+      ${GKICK_RESOURCES})
     target_compile_options(geonkick_common_single PUBLIC ${GKICK_API_PLUGIN_SINGLE_FLAGS})
 endif(GKICK_PLUGIN)
 
@@ -269,7 +257,11 @@
 if (GKICK_STANDALONE)
   message(STATUS "Standalone: yes" )
 else(GKICK_STANDALONE)
-  message(STATUS "Standalone: no")
+  if (GKICK_JACK_NOT_FOUND)
+    message(STATUS "Standalone: no (install jack development library)")
+  else ()
+    message(STATUS "Standalone: no")
+  endif()
 endif(GKICK_STANDALONE)
 
 if (GKICK_PLUGIN_LV2)
@@ -277,6 +269,12 @@
 else(GKICK_PLUGIN_LV2)
   message(STATUS "LV2 plugin: no")
 endif(GKICK_PLUGIN_LV2)
+
+if (GKICK_PLUGIN_VST)
+  message(STATUS "VST plugin: yes" )
+else(GKICK_PLUGIN_VST)
+  message(STATUS "VST plugin: no")
+endif(GKICK_PLUGIN_VST)
 
 if (ENABLE_LOGGING)
   message(STATUS "Debug enabled: yes" )
@@ -290,9 +288,13 @@
 endif (GKICK_STANDALONE)
 
 if (GKICK_PLUGIN)
-	add_subdirectory(plugin)
+  add_subdirectory(plugin)
+  if (GKICK_PLUGIN_VST)
+    add_subdirectory(${GKICK_VST_SDK_PATH})
+  endif(GKICK_PLUGIN_VST)
 endif (GKICK_PLUGIN)
 
 add_subdirectory(data)
 add_subdirectory(presets)
 
+

=== presets/CMakeLists.txt ===
set(GKICK_PRESETS
  AVL-Drumkit.tar.xz
  DigitalSamba.tar.xz
  DSoS.tar.xz
  TimeKit.tar.xz
  UnfaTutorial.tar.xz)

foreach(compressedFolder ${GKICK_PRESETS})
  message(STATUS "uncompress file ${compressedFolder}")
  get_filename_component(presetsFolder ${compressedFolder} NAME)
  string(REPLACE ".tar.xz" "" presetsFolder ${presetsFolder})
  add_custom_command(OUTPUT ${presetsFolder}
    COMMAND tar xvf ${GKICK_PRESETS_DIR}/${compressedFolder})
  set(GKICK_PRESETS_OUTPUT ${GKICK_PRESETS_OUTPUT} ${CMAKE_BINARY_DIR}/presets/${presetsFolder})
endforeach()

add_custom_target(gkick_presets ALL DEPENDS ${GKICK_PRESETS_OUTPUT})
install(DIRECTORY ${GKICK_PRESETS_OUTPUT} DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/geonkick/presets)

=== standalone/CMakeLists.txt ===
set(GKICK_STANDALONE_SOURCES ${GKICK_STANDALONE_DIR}/main.cpp)

add_executable(geonkick
  ${GKICK_COMMON_HEADERS}
  ${GKICK_COMMON_RESOURCES}
  ${GKICK_STANDALONE_SOURCES})

add_dependencies(geonkick api_standalone)
add_dependencies(geonkick redkite)
target_link_libraries(geonkick  geonkick_common api_standalone redkite)
target_link_libraries(geonkick "-lstdc++fs")
target_link_libraries(geonkick "-lX11 -ljack -lsndfile -lrt -lm -ldl -lpthread -lcairo")

install(TARGETS geonkick DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
install(FILES ${GKICK_DOC_DIR}/man/geonkick.1  DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)

=== plugin/lv2/CMakeLists.txt ===
set(GKICK_LV2_SOURCES ${GKICK_LV2_DIR}/geonkick_lv2.cpp)

add_library(geonkick_lv2 SHARED
  ${GKICK_COMMON_HEADERS}
  ${GKICK_COMMON_RESOURCES}
  ${GKICK_LV2_SOURCES})

set_target_properties(geonkick_lv2 PROPERTIES PREFIX "")
target_link_libraries(geonkick_lv2  geonkick_common api_plugin redkite)
target_link_libraries(geonkick_lv2 "-lstdc++fs")
target_link_libraries(geonkick_lv2 "-lX11 -lsndfile -lrt -lm -ldl -lpthread -lcairo")
add_dependencies(geonkick_lv2 api_plugin)
add_dependencies(geonkick_lv2 redkite)

if (GKICK_PLUGIN)
  add_library(geonkick_single_lv2 SHARED
    ${GKICK_COMMON_HEADERS}
    ${GKICK_COMMON_RESOURCES}
    ${GKICK_LV2_SOURCES})
  set_target_properties(geonkick_single_lv2 PROPERTIES PREFIX "")
  target_link_libraries(geonkick_single_lv2  geonkick_common_single api_plugin_single redkite)
  target_link_libraries(geonkick_single_lv2 "-lstdc++fs")
  target_link_libraries(geonkick_single_lv2 "-lX11 -lsndfile -lrt -lm -ldl -lpthread -lcairo")
  add_dependencies(geonkick_single_lv2 api_plugin_single)
  target_compile_options(geonkick_single_lv2 PUBLIC ${GKICK_API_PLUGIN_SINGLE_FLAGS})
  install(TARGETS geonkick_single_lv2 DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/lv2/geonkick.lv2)
endif(GKICK_PLUGIN)

install(TARGETS geonkick_lv2 DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/lv2/geonkick.lv2)
install(DIRECTORY ${GKICK_LV2_DIR}/geonkick.lv2 DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/lv2)

=== plugin/vst/CMakeLists.txt ===
set(GKICK_VST_DIR ${CMAKE_CURRENT_SOURCE_DIR})
if (GKICK_VST_SDK_PATH)
  list(APPEND CMAKE_MODULE_PATH "${GKICK_VST_SDK_PATH}/cmake/modules")
else (GKICK_VST_SDK_PATH)
  message(STATUS "GKICK_VST_SDK_PATH was not set")
endif(GKICK_VST_SDK_PATH)

include_directories(${GKICK_VST_SDK_PATH})
include_directories(${GKICK_REDKITE_SDK_PATH}/include)
link_directories(${GKICK_VST_SDK_PATH}/build/lib)
link_directories(${GKICK_REDKITE_SDK_PATH}/lib)

set(GKICK_VST_HEADERS
  ${GKICK_VST_SDK_PATH}/public.sdk/source/vst/vstsinglecomponenteffect.h
  ${GKICK_VST_DIR}/VstIds.h
  ${GKICK_VST_DIR}/GKickVstProcessor.h
  ${GKICK_VST_DIR}/GKickVstEditor.h)

set(GKICK_VST_SOURCES
  ${GKICK_VST_SDK_PATH}/public.sdk/source/vst/vstsinglecomponenteffect.cpp
  ${GKICK_VST_DIR}/VstFactory.cpp
  ${GKICK_VST_DIR}/GKickVstProcessor.cpp
  ${GKICK_VST_DIR}/GKickVstEditor.cpp)

set(target geonkick_vst)

add_library(${target} SHARED
    ${GKICK_VST_HEADERS} ${GKICK_VST_SOURCES})

set_target_properties(${target} PROPERTIES PREFIX "")
set_target_properties(${target} PROPERTIES OUTPUT_NAME "Geonkick")
set_target_properties(${target} PROPERTIES SUFFIX ".so")

target_link_libraries(${target} PRIVATE geonkick_common api_plugin)
target_link_libraries(${target} PRIVATE "-lstdc++fs")
target_link_libraries(${target} PRIVATE base sdk sdk_common pluginterfaces)
target_link_libraries(${target} PRIVATE "-lredkite -lX11 -lsndfile -lrt -lm -ldl -lpthread -lcairo")
target_link_libraries(${target} PRIVATE "-Wl,--no-undefined")

add_dependencies(${target} geonkick_common)

install(TARGETS geonkick_vst DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/vst3/Geonkick.vst3/Contents/${GKICK_ARCHITECTURE}-linux)

=== redkite/tools/CMakeLists.txt ===
set(RK_TOOLS_SOURCES ${RK_TOOLS_PATH}/rkpng2c.c)

if (RK_GRAPHICS_BACKEND MATCHES Cairo)
  set(RK_GRAPHICS_BACKEND_LINK_LIBS "-lcairo")
endif()

add_executable(rkpng2c ${RK_EXEC_OPTION} ${RK_TOOLS_SOURCES})

if (CMAKE_SYSTEM_NAME MATCHES Windows)
  target_link_libraries(rkpng2c "-mwindows -lstdc++ -lm -lmingw32")
  target_link_libraries(rkpng2c ${RK_GRAPHICS_BACKEND_LINK_LIBS})
else()
  target_link_libraries(rkpng2c ${RK_GRAPHICS_BACKEND_LINK_LIBS})
endif()

#install(TARGETS rkpng2c DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
#install(FILES ${RK_DOC_PATH}/man/rkpng2c.1  DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)

=== debian/changelog ===
geonkick (2.9.0+dfsg-0ubuntu1) jammy; urgency=medium

  * New upstream release
  * d/control: bump standards-version
  * d/copyright: bump dates
  * update d/watch

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sun, 13 Feb 2022 11:12:26 -0800

geonkick (2.8.0-0ubuntu2) impish; urgency=medium

  * Change install directory of LV2 plugin (LP: #1946779)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Tue, 12 Oct 2021 12:40:34 -0700

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  pkg-config,
  rapidjson-dev,
  libsndfile1-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://github.com/iurie-sw/geonkick
 
 Package: geonkick

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake

override_dh_auto_install:
	dh_auto_install
	mv debian/geonkick/usr/lib/*/lv2 debian/geonkick/usr/lib/lv2

## geonkick 2.9.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 3.7)
 
-project(geonkick VERSION 2.9.0)
+project(geonkick VERSION 2.9.2)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")
 include(GNUInstallDirs)
@@ -26,10 +26,10 @@
 endif ()
 
 if (GKICK_ARCHITECTURE MATCHES x86_64)
-  message(STATUS "set optimisation complier flags for ${GKICK_ARCHITECTURE}")
+  message(STATUS "set optimisation compiler flags for ${GKICK_ARCHITECTURE}")
   set(GKICK_OPTIMISATION_FLAGS "-O3 -msse -msse2 -mfpmath=sse -ffast-math -fomit-frame-pointer")
 else ()
-  message(STATUS "set optimisation complier flags for ${GKICK_ARCHITECTURE}")
+  message(STATUS "set optimisation compiler flags for ${GKICK_ARCHITECTURE}")
   set(GKICK_OPTIMISATION_FLAGS "-O3 -ffast-math -fomit-frame-pointer")
 endif ()
 
@@ -57,7 +57,7 @@
 set(GKICK_RC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/resources)
 set(GKICK_STANDALONE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/standalone)
 set(GKICK_UTILS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/utils)
-set(GKICK_REDKITE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/redkite)
+set(GKICK_REDKITE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/redkite)
 
 if (GKICK_PLUGIN)
     if (GKICK_PLUGIN_VST)
@@ -230,12 +230,12 @@
 include_directories(${GKICK_API_DIR}/src)
 include_directories(${GKICK_REDKITE_DIR}/include)
 include_directories(${GKICK_UTILS_DIR})
-link_directories(${CMAKE_BINARY_DIR}/redkite)
+link_directories(${GKICK_REDKITE_DIR})
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 add_definitions(-fPIC)
 add_subdirectory(dsp)
-add_subdirectory(redkite)
+add_subdirectory(${GKICK_REDKITE_DIR})
 include(${GKICK_RC_DIR}/resources.rc)
 
 include_directories(${GKICK_COMMON_DIR})

=== debian/changelog ===
geonkick (2.9.2+dfsg-0ubuntu1) mantic; urgency=medium

  * New upstream release 2.9.2+dfsg
    - Just bug fixes
  * d/control: bump standards-version
  * d/copyright: bump dates

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sun, 20 Aug 2023 09:56:50 -0700

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  pkg-config,
  rapidjson-dev,
  libsndfile1-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/iurie-sw/geonkick
 
 Package: geonkick
